[Pkg-irc-commits] r220 - in /packages/ngircd/trunk/debian: changelog ngircd.conf ngircd.init patches/00list rules

mario at users.alioth.debian.org mario at users.alioth.debian.org
Sat Sep 13 18:01:35 UTC 2008


Author: mario
Date: Sat Sep 13 18:01:35 2008
New Revision: 220

URL: http://svn.debian.org/wsvn/pkg-irc/?sc=1&rev=220
Log:
New init-script, some smaller changes on the config file...

Removed:
    packages/ngircd/trunk/debian/patches/00list
Modified:
    packages/ngircd/trunk/debian/changelog
    packages/ngircd/trunk/debian/ngircd.conf
    packages/ngircd/trunk/debian/ngircd.init
    packages/ngircd/trunk/debian/rules

Modified: packages/ngircd/trunk/debian/changelog
URL: http://svn.debian.org/wsvn/pkg-irc/packages/ngircd/trunk/debian/changelog?rev=220&op=diff
==============================================================================
--- packages/ngircd/trunk/debian/changelog (original)
+++ packages/ngircd/trunk/debian/changelog Sat Sep 13 18:01:35 2008
@@ -1,11 +1,13 @@
 ngircd (0.12.1-1) unstable; urgency=low
 
-  * New upstream release
-  * Maintainer set to Debian IRC Team
-  * Added Vcs-* fields in debian/control
-  * Added Homepage field in debian/control
-  * Removed Homepage from description field in debian/control
-  * Bumped policy version to 3.8.0
+  * New upstream release (Closes: #465815, #466063).
+  * Maintainer set to Debian IRC Team.
+  * Added Vcs-* fields in debian/control.
+  * Added Homepage field in debian/control.
+  * Removed Homepage from description field in debian/control.
+  * Bumped policy version to 3.8.0.
+  * Enabled syslog (Closes: #452028).
+  * New init-script derived from actual dh-templates. (Closes: #478338).
 
  -- Mario Iseli <mario at debian.org>  Sat, 13 Sep 2008 16:47:32 +0200
 

Modified: packages/ngircd/trunk/debian/ngircd.conf
URL: http://svn.debian.org/wsvn/pkg-irc/packages/ngircd/trunk/debian/ngircd.conf?rev=220&op=diff
==============================================================================
--- packages/ngircd/trunk/debian/ngircd.conf (original)
+++ packages/ngircd/trunk/debian/ngircd.conf Sat Sep 13 18:01:35 2008
@@ -1,10 +1,8 @@
 #
 # This is only a sample configuration for Debian
-# written by Mario Iseli
 #
 # The original can be found at:
 # /usr/share/doc/ngircd/examples/sample-ngircd.conf.gz
-#
 
 [Global]
 
@@ -48,6 +46,7 @@
 	# Do NOT change this on Debian! It runs with the default user 'irc'
 	;ServerUID = 65534
 	;ServerGID = 65534
+	# Do NOT change this on Debian! The Initscript takes care of this file!
 	PidFile = /var/run/ngircd/ngircd.pid
 
 	# After <PingTimeout> seconds of inactivity the server will send a
@@ -131,12 +130,12 @@
 	# There may be more than one [Channel] block.
 
 	# Name of the channel
-	Name = #ngircd
+	;Name = #ngircd
 
 	# Topic for this channel
 	;Topic = Our ngircd testing channel
 
 	# Initial channel modes
-	Modes = tn
+	;Modes = tn
 
 # -eof-

Modified: packages/ngircd/trunk/debian/ngircd.init
URL: http://svn.debian.org/wsvn/pkg-irc/packages/ngircd/trunk/debian/ngircd.init?rev=220&op=diff
==============================================================================
--- packages/ngircd/trunk/debian/ngircd.init (original)
+++ packages/ngircd/trunk/debian/ngircd.init Sat Sep 13 18:01:35 2008
@@ -1,68 +1,259 @@
-#! /bin/sh
-
-# ngircd	Start/stop the Next Generation IRC Server
-# Version:	ngircd  0.9.2  16-Nov-2005
-# Autor:	Mario Iseli <admin at marioiseli.com>
-
+#!/bin/sh
+
+# Copyright (c) 2007 Javier Fernandez-Sanguino <jfs at debian.org>
+#
+# This is free software; you may redistribute it and/or modify
+# it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2,
+# or (at your option) any later version.
+#
+# This is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License with
+# the Debian operating system, in /usr/share/common-licenses/GPL;  if
+# not, write to the Free Software Foundation, Inc., 59 Temple Place,
+# Suite 330, Boston, MA 02111-1307 USA
+#
 ### BEGIN INIT INFO
-# Provides:		ircd
-# Required-Start:	$syslog
-# Required-Stop:	$syslog
-# Should-Start:		$local_fs, $network
-# Should-Stop:		$local_fs, $network
-# Default-Start:	2 3 4 5
-# Default-Stop:		0 1 6
-# Short-Description:	Next Generation IRC Server
-# Description:		Starts ngircd in a proper way
+# Provides:          ngircd
+# Required-Start:    $network $local_fs
+# Required-Stop:
+# Should-Start:      $named
+# Should-Stop:
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Next generation IRC daemon
+# Description:       Simple IRC daemon written from scratch
 ### END INIT INFO
 
-PATH=/sbin:/bin:/usr/sbin:/usr/bin
-
-test -f /usr/sbin/ngircd || exit 0
+PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
+
+DAEMON=/usr/sbin/ngircd
+NAME=ngircd
+DESC="Next generation IRC daemon"
+LOGDIR=/var/log/
+
+PIDFILE=/var/run/ngircd/$NAME.pid
+
+test -x $DAEMON || exit 0
+
+. /lib/lsb/init-functions
+
+DAEMON_OPTS="-n"          # Additional options given to the server
+
+DIETIME=10              # Time to wait for the server to die, in seconds
+
+LOGFILE=$LOGDIR/$NAME.log  # Server logfile
+DAEMONUSER="irc"
+
+if [ -n "$DAEMONUSER" ] ; then
+    if getent passwd | grep -q "^$DAEMONUSER:"; then
+        # Obtain the uid and gid
+        DAEMONUID=`getent passwd |grep "^$DAEMONUSER:" | awk -F : '{print $3}'`
+        DAEMONGID=`getent passwd |grep "^$DAEMONUSER:" | awk -F : '{print $4}'`
+    else
+        log_failure_msg "The user $DAEMONUSER, required to run $NAME does not exist."
+        exit 1
+    fi
+fi
+
 
 set -e
 
+running_pid() {
+# Check if a given process pid's cmdline matches a given name
+    pid=$1
+    name=$2
+    [ -z "$pid" ] && return 1
+    [ ! -d /proc/$pid ] &&  return 1
+    cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
+    # Is this the expected server
+    [ "$cmd" != "$name" ] &&  return 1
+    return 0
+}
+
+running() {
+# Check if the process is running looking at /proc
+# (works for all users)
+
+    # No pidfile, probably no daemon present
+    [ ! -f "$PIDFILE" ] && return 1
+    pid=`cat $PIDFILE`
+    running_pid $pid $DAEMON || return 1
+    return 0
+}
+
+start_server() {
+# Start the process using the wrapper
+        if [ -z "$DAEMONUSER" ] ; then
+            start_daemon -p $PIDFILE $DAEMON -- $DAEMON_OPTS
+            errcode=$?
+        else
+# if we are using a daemonuser then change the user id
+            start-stop-daemon --start --quiet --pidfile $PIDFILE \
+                        --chuid $DAEMONUSER \
+                        --exec $DAEMON -- $DAEMON_OPTS
+            errcode=$?
+        fi
+	return $errcode
+}
+
+stop_server() {
+# Stop the process using the wrapper
+        if [ -z "$DAEMONUSER" ] ; then
+            killproc -p $PIDFILE $DAEMON
+            errcode=$?
+        else
+# if we are using a daemonuser then look for process that match
+            start-stop-daemon --stop --quiet --pidfile $PIDFILE \
+                        --user $DAEMONUSER \
+                        --exec $DAEMON
+            errcode=$?
+        fi
+
+	return $errcode
+}
+
+reload_server() {
+    [ ! -f "$PIDFILE" ] && return 1
+    pid=pidofproc $PIDFILE # This is the daemon's pid
+    # Send a SIGHUP
+    kill -1 $pid
+    return $?
+}
+
+force_stop() {
+# Force the process to die killing it manually
+	[ ! -e "$PIDFILE" ] && return
+	if running ; then
+		kill -15 $pid
+	# Is it really dead?
+		sleep "$DIETIME"s
+		if running ; then
+			kill -9 $pid
+			sleep "$DIETIME"s
+			if running ; then
+				echo "Cannot kill $NAME (pid=$pid)!"
+				exit 1
+			fi
+		fi
+	fi
+	rm -f $PIDFILE
+}
+
+
 case "$1" in
-
   start)
-	echo -n "Starting Next generation IRC server: "
-	start-stop-daemon --start --chuid irc:irc \
-	--make-pidfile --background \
-	--pidfile /var/run/ngircd/ngircd.pid \
-	--exec /usr/sbin/ngircd -- -n
-	echo "ngircd."
-	;;
-
+	log_daemon_msg "Starting $DESC " "$NAME"
+        # Check if it's running first
+        if running ;  then
+            log_progress_msg "apparently already running"
+            log_end_msg 0
+            exit 0
+        fi
+        if start_server ; then
+            # NOTE: Some servers might die some time after they start,
+            # this code will detect this issue if STARTTIME is set
+            # to a reasonable value
+            [ -n "$STARTTIME" ] && sleep $STARTTIME # Wait some time 
+            if  running ;  then
+                # It's ok, the server started and is running
+                log_end_msg 0
+            else
+                # It is not running after we did start
+                log_end_msg 1
+            fi
+        else
+            # Either we could not start it
+            log_end_msg 1
+        fi
+	;;
   stop)
-	echo -n "Stopping Next generation IRC server: "
-	start-stop-daemon --stop --quiet \
-	--pidfile /var/run/ngircd/ngircd.pid \
-	--exec /usr/sbin/ngircd
-	rm -f /var/run/ngircd/ngircd.pid
-	echo "ngircd."
-	;;
-
-  reload|force-reload)
-	echo -n "Reloading Next generation IRC server configuration: "
-	start-stop-daemon --stop --quiet --oknodo --signal 1 \
-	--pidfile /var/run/ngircd/ngircd.pid \
-	--exec /usr/sbin/ngircd
-	echo "ngircd."
-	;;
-
-  restart)
-	echo -n "Restarting Next generation IRC server: "
-	$0 stop
-	sleep 1
-	$0 start
-	echo "ngircd."
-	;;
+        log_daemon_msg "Stopping $DESC" "$NAME"
+        if running ; then
+            # Only stop the server if we see it running
+			errcode=0
+            stop_server || errcode=$?
+            log_end_msg $errcode
+        else
+            # If it's not running don't do anything
+            log_progress_msg "apparently not running"
+            log_end_msg 0
+            exit 0
+        fi
+        ;;
+  force-stop)
+        # First try to stop gracefully the program
+        $0 stop
+        if running; then
+            # If it's still running try to kill it more forcefully
+            log_daemon_msg "Stopping (force) $DESC" "$NAME"
+			errcode=0
+            force_stop || errcode=$?
+            log_end_msg $errcode
+        fi
+	;;
+  restart|force-reload)
+        log_daemon_msg "Restarting $DESC" "$NAME"
+		errcode=0
+        stop_server || errcode=$?
+        # Wait some sensible amount, some server need this
+        [ -n "$DIETIME" ] && sleep $DIETIME
+        start_server || errcode=$?
+        [ -n "$STARTTIME" ] && sleep $STARTTIME
+        running || errcode=$?
+        log_end_msg $errcode
+	;;
+  status)
+
+        log_daemon_msg "Checking status of $DESC" "$NAME"
+        if running ;  then
+            log_progress_msg "running"
+            log_end_msg 0
+        else
+            log_progress_msg "apparently not running"
+            log_end_msg 1
+            exit 1
+        fi
+        ;;
+  # Use this if the daemon cannot reload
+  reload)
+        log_warning_msg "Reloading $NAME daemon: not implemented, as the daemon"
+        log_warning_msg "cannot re-read the config file (use restart)."
+        ;;
+  # And this if it cann
+  #reload)
+          #
+          # If the daemon can reload its config files on the fly
+          # for example by sending it SIGHUP, do it here.
+          #
+          # If the daemon responds to changes in its config file
+          # directly anyway, make this a do-nothing entry.
+          #
+          # log_daemon_msg "Reloading $DESC configuration files" "$NAME"
+          # if running ; then
+          #    reload_server
+          #    if ! running ;  then
+          # Process died after we tried to reload
+          #       log_progress_msg "died on reload"
+          #       log_end_msg 1
+          #       exit 1
+          #    fi
+          # else
+          #    log_progress_msg "server is not running"
+          #    log_end_msg 1
+          #    exit 1
+          # fi
+                                                                                    #;;
 
   *)
-	echo "Usage: $0 {start|stop|restart|reload|force-reload}" >&2
+	N=/etc/init.d/$NAME
+	echo "Usage: $N {start|stop|force-stop|restart|force-reload|status}" >&2
 	exit 1
 	;;
-
 esac
 
 exit 0

Modified: packages/ngircd/trunk/debian/rules
URL: http://svn.debian.org/wsvn/pkg-irc/packages/ngircd/trunk/debian/rules?rev=220&op=diff
==============================================================================
--- packages/ngircd/trunk/debian/rules (original)
+++ packages/ngircd/trunk/debian/rules Sat Sep 13 18:01:35 2008
@@ -5,9 +5,17 @@
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 
+CFLAGS = -Wall -g
+
+ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
+        CFLAGS += -O0
+else
+        CFLAGS += -O2
+endif
+
 config.status: patch configure
 	dh_testdir
-	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --sysconfdir=/etc/ngircd --without-syslog --without-epoll
+	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --sysconfdir=/etc/ngircd --without-epoll
 
 
 build: build-stamp




More information about the Pkg-irc-commits mailing list